Y_csgoto
2019-12-05 20:48
采纳率: 100%
浏览 529
已采纳

为什么Java书中实现Java异常链时,在catch{}模块中已经用throw再次抛出了一个异常,却还要在方法定义时throws这个类的异常?

最近学习了Java的异常链机制,发现了一个问题,就是作者实现Java异常链的时候总是在方法定义处throws方法体中已经throw过实例的异常类,显得有些赘余,我想请问这是在干什么,throws和throw不配套使用也不会出错,这样做只是为了什么?以为了后能看得懂?

public class ExceptionList {

    public void firstStep() throws MyException{
        throw new MyException();
    }
    //这里又throws了catch子句里已经抛出的异常
    public void SecondStep() throws AutoDefinedRuntimeException{
        try {
            ExceptionList eList = new ExceptionList();
            eList.firstStep();
        }
        catch(MyException me1) {
            //me1.getMessage();
            me1.printStackTrace();
            throw new AutoDefinedRuntimeException(me1);//抛出更高级的异常
        }
    }


    public static void main(String[] args) {
        // TODO Auto-generated method stub
        try{
            ExceptionList eList = new ExceptionList();
            eList.SecondStep();
        }
        catch(AutoDefinedRuntimeException me2) {
            //me2.getMessage();
            me2.printStackTrace();
        }
    }

}

  • 写回答
  • 好问题 提建议
  • 追加酬金
  • 关注问题
  • 邀请回答

2条回答 默认 最新

相关推荐 更多相似问题